package com;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;

import com.dto.TermInvertedIndex;
import com.helper.BagOfWordsHelper;

public class BagOfWords {

	BagOfWordsHelper bagOfWordsHelper;
	List<TermInvertedIndex> termList;
	
	public BagOfWords() {
		// TODO Auto-generated constructor stub
		bagOfWordsHelper = new BagOfWordsHelper();
		termList = new ArrayList<TermInvertedIndex>();
	}
	
	public void parseText(String filename)
	{
		Document doc;
		TermInvertedIndex termInv;
		String text="";
		
		BufferedReader br;
		try {
				
				br = new BufferedReader(new FileReader(new File(filename)));
				long docCount=0;
				String line;
				while ((line = br.readLine()) != null)
				{
					if(line.isEmpty()){
						docCount++;
						continue;
					}
					if (line.contains("http"))
					{
						doc = Jsoup.connect(line).get();
						text = doc.body().text();
					}
					else
					{
						text=line;
					}
					docCount++;
					processText(text, docCount);
				}
				
				
				 //get only text from the HTML page
				 
			
			/* ------------------------ ENABLE FOR AD BAG WORDS AND COMMENT ABOVE---------------------------- */
			
//			BufferedReader br;
//			br = new BufferedReader(new FileReader(new File("G:\\ads_list.txt")));
//			//String line;
//			long adCount=0;
//			while ((text = br.readLine()) != null)
//			{
//			    adCount++;
//				processText(text,adCount);
//			 /*--------------------------------------------------------------------------------*/
//			
//			}
			//processText(text, docCount);
		}catch(Exception e)
		{ 
			e.printStackTrace();
		}
	}
	
	public List<TermInvertedIndex> processText(String text, long docCount)
	{
		TermInvertedIndex termInv;
		try{
				if(text !=null)
				{
					String[] tagsArr = text.split(" ");
					
					//String[] tagsArr = {"secure", "online", "back","up"};
					
					for(int i=0; i<tagsArr.length;i++)
					{
						// check if term already present in list, then just update respective counter
						String term=tagsArr[i].replaceAll("[^\\w\\d]", "").toLowerCase();
						//String term = tempTerm.replaceAll("[-+.^:,?]", "").trim();
						//String term=tagsArr[i].trim();
						if(term.isEmpty()) {
							continue;
						}
						TermInvertedIndex tempInvertedIndex= getTermInList(term);
						if(tempInvertedIndex!=null)
						{
							tempInvertedIndex.setTermFrequency(tempInvertedIndex.getTermFrequency()+1);
							tempInvertedIndex.setDocIndex(setDocumentIndex(tempInvertedIndex,docCount,i));
						}
						else
						{
							termInv = new TermInvertedIndex();
							termInv.setTerm(term);
							termInv.setTermFrequency(1);
							
							Map<Long,List<Long>> docIndex =new HashMap<Long, List<Long>>();
							List<Long> position = new ArrayList<Long>();
							position.add((long)i);
							docIndex.put(new Long(docCount),position);
							
							termInv.setDocIndex(docIndex);
							termList.add(termInv);
						}
					}
					
				}	
				
		} catch(Exception e)
		{
			e.printStackTrace();
		}
		return termList;
	}
	
	public void createBagofWords(String filename)
	{
		// get list of urls from file
	//	List<String> urls = new ArrayList<String>(); 
	//urls = bagOfWordsHelper.readfile(filename);
		
		//parseText from every Url in list 
		//long docCount=1;
	//for(String tempUrl : urls)
		{
			parseText(filename);
			//parseText("G:\\ads_list.txt",2465);
		}
		bagOfWordsHelper.writeToFile(termList);
	}
	
	public TermInvertedIndex getTermInList(String term)
	{
		TermInvertedIndex tempInvertedIndex=null;
		
		for(TermInvertedIndex tempIndex : termList)
		{
			if(tempIndex.getTerm().equalsIgnoreCase(term))
			{
				tempInvertedIndex=tempIndex;
			}
		}
		return tempInvertedIndex;
	}
	
	
	public Map<Long,List<Long>> setDocumentIndex(TermInvertedIndex temIndex,long docCount, long position)
	{
		Map<Long,List<Long>> tempMap = temIndex.getDocIndex();
		
		if(tempMap.containsKey(docCount))
		{
			ArrayList<Long> positions = (ArrayList<Long>) tempMap.get(docCount);
			tempMap.remove(docCount);
			positions.add(position);
			tempMap.put(docCount,positions);
		}
		else
		{
			ArrayList<Long> positions = new ArrayList<Long>();
			positions.add(position);
			tempMap.put(docCount, positions);
		}
		return tempMap;
	}
	
	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		
		BagOfWords bagOfWords = new BagOfWords();
		bagOfWords.createBagofWords("G:\\SJSU course\\fall 14\\CS 297\\bagOfWords\\att2\\docs.txt");
	}
}
