package com;

import java.io.BufferedReader;
import java.io.Console;
import java.io.File;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Scanner;
import java.util.Set;
import java.util.SortedSet;
import java.util.TreeMap;
import java.util.TreeSet;

import com.helper.IRServiceHelper;

public class CosineSimilarity {

	long[][] queryArray;
	long[][] docVectorArray;
	long[][] adsVectorArray;
	long[][] adInputVector;
	long termCount;
	long wordsCount;
	IRServiceHelper irServiceHelper;
	Map<Long,String> documentList;
	Map<Long,String> queryList;
	
	public CosineSimilarity()
	{
		irServiceHelper = new IRServiceHelper();
		documentList = readLines("G:\\SJSU course\\fall 14\\CS 297\\urls.txt");
		queryList = readLines("G:\\SJSU course\\fall 14\\CS 297\\bagOfWords\\att2\\ads_list2.txt");
	}
	
	public void init()
	{
		termCount=IRServiceHelper.countLines("G:\\SJSU course\\fall 14\\CS 297\\bagOfWords\\att2\\bagofwords.txt");
		wordsCount=IRServiceHelper.countLines("G:\\SJSU course\\fall 14\\CS 297\\bagOfWords\\att1\\ads_list.txt");
	}
	
	public void findCosine(String query)
	{
		String[] breakQuery = query.split(" ");		
		Map<Long,Double> consineResult = new HashMap<Long,Double>();
		List<Long> docIds = new ArrayList<Long>(); 
		
		if(breakQuery!=null)
		{
			init();
			buildqueryVector(breakQuery);
			 docVectorArray= getdocumentVectorFromfile("G:\\SJSU course\\fall 14\\CS 297\\bagOfWords\\att2\\document_vector.txt",termCount);
			// adsArray = getdocumentVectorFromfile("G:\\SJSU course\\fall 14\\CS 297\\bagOfWords\\att1\\ads_list.txt", wordsCount);
			 
			for(int j=0;j< queryArray.length; j++)
			{
			
			for(int i=0;i < docVectorArray.length;i++)
			{
				double result = (getDotProduct(queryArray[j], docVectorArray[i]))/calculateDistance(queryArray[j], docVectorArray[i]);
				System.out.println(" cosine similarity for given query with document "+ i+" :"+ result );
				consineResult.put(new Long(i), result);
			}
			}
			for(Map.Entry<Long,Double> entry : entriesSortedByValues(consineResult)) {
				  System.out.println(documentList.get(entry.getKey()) + " => " + entry.getValue());
				  
				  if(entry.getValue()!=0)
				  {
					  docIds.add(entry.getKey());
				  }
				}
			
			Map<String,Long> docKeyword = irServiceHelper.getKeywordsFromResultDocs(docIds);
//			Map<String,Long> adsKeyword = irServiceHelper.getKeywordsFromads();
			Map<String,Long> bagOfWords = irServiceHelper.getBagOfWords("G:\\SJSU course\\fall 14\\CS 297\\bagOfWords\\att2\\bagofwords.txt");
			
			//Set<Long> bagOfWordsKey = bagOfWords.keySet();
			
			adInputVector = new long[1][(int) termCount];
			
			// build input vector for ads based on keywords from documents from search result.
			
			int count =1;
			for(Map.Entry<String,Long> entry : docKeyword.entrySet()) {
				 
						if(count==1)
						{
							count++;
							continue;
						}
				 		if(bagOfWords.containsKey(entry.getKey()))
				 		{
				 			adInputVector[0][Integer.valueOf((bagOfWords.get(entry.getKey()).intValue()-1))] = entry.getValue();
				 		}
				}
			
			//  find ads vector
			adsVectorArray =  new long [(int) wordsCount][(int) termCount]; 
			adsVectorArray	= irServiceHelper.buildAdvector(termCount, bagOfWords,
					"G:\\SJSU course\\fall 14\\CS 297\\bagOfWords\\att2\\ads_list2.txt");
		
			
			// find cosine similarity between document vector generated from documents appearing on search results
			// page and adsvector
			Map<Long,Double> adsMap = new HashMap<Long, Double>();
			
			for(int i=10;i< adsVectorArray.length ;i++)
			{
				long[] adArray = new long[(int) termCount];
				for(int j=0; j < adsVectorArray.length;j++)
				{
					adArray[j] = adsVectorArray[i][j];
					if(adsVectorArray[i][j] > 0)
					{
						//System.out.println(" ads word at "+j+"  "+adsVectorArray[i][j]);
					}
				}
				double adResult=(getDotProduct(adInputVector[0],adArray))/calculateDistance(adInputVector[0],adArray);
				adsMap.put((long) i,adResult);
			}
			
			System.out.println("  ");
			int adCount=0;
			for(Map.Entry<Long,Double> entry : entriesSortedByValues(adsMap)) {
				adCount++;
				System.out.println(queryList.get(entry.getKey())+" = >" + entry.getValue());
				if(adCount==50){
					break;
				}
			}
		}
	}
	
	public void buildqueryVector(String[] breakQuery)
	{
		BufferedReader br;
		queryArray = new long[1][(int)termCount];		
		try
		{
			br= new BufferedReader(new FileReader(new File("G:\\SJSU course\\fall 14\\CS 297\\bagOfWords\\att2\\bagofwords.txt")));
			int qCount=0;
			while(qCount < breakQuery.length)
			{
				String line;
				long lineCount=0, fCount=1;
				while ((line = br.readLine()) != null)
				{
					if(line.toLowerCase().contains(breakQuery[qCount].toLowerCase()))
					{
						queryArray[qCount][(int)lineCount]=fCount;						
					}
					//queryList.put(lineCount, line);
					lineCount++;					
				}
				qCount++;
			}
			br.close();
		}catch(Exception e)
		{
			e.printStackTrace();
		}
		
	}
	
	public long[][] getdocumentVectorFromfile(String filename, long count)
	{
		BufferedReader br;
		 long[][] docVectorArray = new long [10][(int)count] ;
		
		try{
			br= new BufferedReader(new FileReader(new File(filename)));
			String docLine;
			int i=0;
			while((docLine = br.readLine()) != null)
			{
				if(docLine.isEmpty())
				{
					continue;
				}
				String[] docLineArr = docLine.split(",");
				int j=0;
				while( j < docLineArr.length)
				{
					docVectorArray[i][j]=Long.parseLong(docLineArr[j]);
					//System.out.println("  " +docVectorArray[i][j]);
					j++;
				}
				System.out.println("Document vector created for document :" +i);
				//documentList.put((long)i, docLine);
				i++;
			}
			
		}catch(Exception e)
		{
			e.printStackTrace();
		}
		
		return docVectorArray;
	}
	
	public static double calculateDistance(long[] queryArray, long[] docArray)
    {
        double Sum = 0.0;
        for(int i=0;i<queryArray.length;i++) {
           Sum = Sum + Math.pow((queryArray[i]-docArray[i]),2.0);
        }
        return Math.sqrt(Sum);
    }
	
	public static double getDotProduct(long[] queryArray, long[] docArray)
	{
		double sum=0;
		for (int i = 0; i < queryArray.length; i++) {
            sum += queryArray[i] * docArray[i];    
        }
		return sum;
	}
	
	public Map<Long,String> readLines(String filename)
	{
		long count=0;
		Map<Long,String> readLineList = new HashMap<Long, String>();
		try {
			BufferedReader br = new BufferedReader(new FileReader(new File(filename)));
			String line;
			while((line = br.readLine()) != null)
			{
				readLineList.put(count, line);
				count++;
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return readLineList;
	}

	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		
		System.out.println("Enter search query: ");
		Scanner in = new Scanner(System.in);
		String input = in.nextLine();
		
		CosineSimilarity cosineSimilarity = new CosineSimilarity();
		cosineSimilarity.findCosine(input);
		
	}



static <K,V extends Comparable<? super V>> List<Map.Entry<K,V>> entriesSortedByValues(Map<K,V> map) {
	List<Entry<K,V>> sortedEntries = new ArrayList<Entry<K,V>>(map.entrySet());

    Collections.sort(sortedEntries, 
            new Comparator<Entry<K,V>>() {
                @Override
                public int compare(Entry<K,V> e1, Entry<K,V> e2) {
                    return e2.getValue().compareTo(e1.getValue());
                }
            }
    );

    return sortedEntries;
}
}