package com;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.List;

import com.helper.IRServiceHelper;

public class DocumentVector {
	
	long docCount;
	long termCount;
	String docFile;
	String termFile;
	
	long[][] docArray;
	//String[] termArray;

	public DocumentVector(String docFile, String termFile)
	{
		this.docFile =docFile;
		this.termFile=termFile;
		
		//docArray= new ArrayList<Long>();
		//termArray= new ArrayList<Long>();
	}
	
	public void init()
	{
		docCount= IRServiceHelper.countLines(docFile);
		termCount= IRServiceHelper.countLines(termFile);
		
		docArray = new long[(int) docCount][(int)termCount];
		//termArray = new String[(int) termCount];
	}
	
	public void buildDocumentVector()
	{
		init();
		BufferedReader br;
		long lineCount=0;
		long docNumber;
		//String line="comment 3  1 : 27, 571, 5 : 602, ";
		List<List<Long>> termDocVector = new ArrayList<List<Long>>();
				
		try {
			br = new BufferedReader(new FileReader(new File(termFile)));
			String line;
			while ((line = br.readLine()) != null) {
				lineCount++;
				//line="off 9  1 : 4, 156, 3 : 248, 5 : 197, ";
				String[] inputSplit = line.split(" ");
				
				if(inputSplit!=null)
				{
					int i=0;
					while(i<inputSplit.length)
					{
						if(inputSplit[i].contains(":"))
						{
							int j=i+1;
							int fCount=0;
							while(!inputSplit[j].equals(":"))
							{
								if(inputSplit[j]!=null || !inputSplit.equals(" ") || !inputSplit[i].isEmpty()){
									fCount++;
								}
								j++;
								if(j >inputSplit.length-1){
									fCount++;
									break;
								}
							}
							docNumber=Long.parseLong(inputSplit[i-1].trim());
							if(docNumber < 10){
								System.out.println(" line :"+lineCount);
								docArray[(int)docNumber-1][(int)lineCount-1]=fCount-1;
							}
							i=j;
						}
						else{
							i++;
						}
					}
				}
			}
			IRServiceHelper.writeArrayToFile(docArray);
			br.close();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void buildQueryVector()
	{
		
	}
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		
		String dFile="G:\\SJSU course\\fall 14\\CS 297\\urls.txt";
		//String tFile="G:\\adsInv.txt";
		
		//String dFile="G:\\SJSU course\\fall 14\\CS 297\\bagOfWords\\att1\\ads_list.txt";
		String tFile="G:\\SJSU course\\fall 14\\CS 297\\bagOfWords\\att2\\bagofwords.txt";
		
		DocumentVector documentVector = new DocumentVector(dFile,tFile);
		documentVector.buildDocumentVector();
	}
}
