package com.helper;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;

public class IRServiceHelper {
	
	BagOfWordsHelper bagOfWordsHelper;
	
	public IRServiceHelper()
	{
		bagOfWordsHelper = new BagOfWordsHelper();
	}
	
	public static long countLines(String filename)
	{
		long count=0;
		try {
			Scanner scanner = new Scanner(new File(filename));
			while(scanner.hasNextLine())
			{
				count++;
				scanner.nextLine();
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return count;
	}
	
	public static void writeArrayToFile(long[][] docvector)
	{
		FileWriter writer;
		StringBuilder strText = new StringBuilder();
		
		try {
				writer = new FileWriter("G:\\SJSU course\\fall 14\\CS 297\\bagOfWords\\att2\\document_vector.txt");	
				
				//writer.write("[ ");
				for(int i=0;i < docvector.length ; i++ )
				{
					//writer.write("[");
					for(int j=0 ; j< docvector[i].length ;j++)
					{
						writer.write(docvector[i][j]+",");
					}
					//writer.write("],");
					writer.write(System.lineSeparator());
					writer.write(System.lineSeparator());
				}
				//writer.write(" ]");
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
				
	}
	
	public static void readLinesforAd(String fileName)
	{
		long countFiles=0;
		BufferedReader br;
		List<String> adFileNames = new ArrayList<String>();
		// get number of files for advertisement
		try {
			br = new BufferedReader(new FileReader(new File(fileName)));
			String line;
			while ((line = br.readLine()) != null)
			{
				adFileNames.add(line.trim());
				countFiles++;
				//scanner.nextLine();
			}
			br.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		// count number of lines from each file
		long count=0;
		String txtLine;
		try {
			Writer writer = new FileWriter("G:\\ads_list.txt");
			for(String tempfile : adFileNames)
			{	
			
				br = new BufferedReader(new FileReader(new File(tempfile)));
				while ((txtLine = br.readLine()) != null)
			{
					String[] tempStr = txtLine.split("	");
					if(tempStr!=null && tempStr.length >=8)
					{
					String temp = tempStr[7];
					
					char[] tempArr = temp.toCharArray();
							
					String finalTemp="";
					for(int i=0 ;i< tempArr.length ;i++)
					{
						if(Character.isLetter(tempArr[i]) || Character.isDigit(tempArr[i]) || tempArr[i]==' ')
						{
							finalTemp= finalTemp + tempArr[i];
						}		
					}
					
				writer.write(finalTemp);
				writer.write(System.lineSeparator());
				count++;
				//scanner.nextLine();
			}
		}
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public Map<String,Long> getKeywordsFromResultDocs(List<Long> docIds)
	{
		Document doc;
		String text;
		Map<String,Long> docKeyword = new HashMap<String,Long>();
		
		List<String> docs = bagOfWordsHelper.readfile("G:\\SJSU course\\fall 14\\CS 297\\urls.txt");
		
		BufferedReader br;
	try {
				for(long tempdocId : docIds)
			{
				String line = docs.get((int) tempdocId);	
				//br = new BufferedReader(new FileReader(new File(filename)));
				long docCount=0;
				//String line;
				//while ((line = br.readLine()) != null)
				{
					if (line.contains("http"))
					{
						doc = Jsoup.connect(line).get();
						text = doc.body().text();
					}
					else
					{
						text=line;
					}
					if(text !=null)
					{
						String[] tagsArrTemp = text.split(" ");
						
						String[] tagsArr = StopWordsHelper.removeStopWords(tagsArrTemp);
						
						for(int i=0; i<tagsArr.length;i++)
						{
							// check if term already present in list, then just update respective counter
							String term=tagsArr[i].replaceAll("[^\\w\\d]", "");
							//System.out.print(" "+term);
							//String term=text.replaceAll("[^\\w\\d]", "");						
							if(docKeyword.containsKey(term))
							{
								docKeyword.put(term, docKeyword.get(term)+1);
							}
							else
							{
								docKeyword.put(term, 1L);
							}
						}
						System.out.println();
					}
				}
			}
	}catch(Exception e)
	{
		e.printStackTrace();
	}
	return docKeyword;
}
	
	public Map<String,Long> getKeywordsFromads()
	{
		String text;
		Map<String,Long> adsKeyword = new HashMap<String,Long>();
		
		List<String> ads = bagOfWordsHelper.readfile("G:\\SJSU course\\fall 14\\CS 297\\bagOfWords\\att1\\ads_list.txt");
		
		try {
			for(String temAdLine : ads)
			{
					text=temAdLine;
				
				if(text !=null && !text.isEmpty())
				{
					//String[] tagsArr = text.split(" ");
					
					//for(int i=0; i<tagsArr.length;i++)
					//{
						// check if term already present in list, then just update respective counter
						//String term=tagsArr[i].replaceAll("[^\\w\\d]", "");
						
					String term=text.replaceAll("[^\\w\\d]", "");
					
						if(adsKeyword.containsKey(term))
						{
							adsKeyword.put(term, adsKeyword.get(term)+1);
						}
						else
						{
							adsKeyword.put(term, 1L);
						}
					//}
				}
			}
		}catch(Exception e)
		{
			e.printStackTrace();
		}

		return null;
	}

	public Map<String,Long> getBagOfWords(String fileName)
	{
		Map<String,Long> bagOfWords = new HashMap<String,Long>();
		BufferedReader br;
		try {
			br = new BufferedReader(new FileReader(new File(fileName)));
			
			String line;
			long linecount=0;
			while ((line = br.readLine()) != null) {
				
				linecount++;
				String[] inputSplit = line.split(" ");
				
				if(inputSplit!=null)
				{
					bagOfWords.put(inputSplit[0],linecount);
				}
			}
		}catch(Exception e)
		{
			e.printStackTrace();
		}
		
		return bagOfWords;
	}
	
	
	public long[][] buildAdvector(long termCount, Map<String,Long> bagOfWords,String filename)
	{
		BufferedReader br;
		long wordcount = IRServiceHelper.countLines(filename);
		
		long[][] advectorArray = new long [(int)wordcount][(int)termCount];
		
		try {
				br = new BufferedReader(new FileReader(new File(filename)));
				String line;
				long linecount=0;
				while ((line = br.readLine()) != null) {
					linecount++;
					String[] inputSplit = line.split(" ");
					
					if(inputSplit!=null && inputSplit.length >0)
					{
						for(int i=0;i< inputSplit.length;i++ )
						{
							if(bagOfWords.containsKey(inputSplit[i]))
							{
								long temp = advectorArray[(int)linecount-1][Integer.valueOf(bagOfWords.get(inputSplit[i]).intValue())-1];
								advectorArray[(int)linecount-1][Integer.valueOf(bagOfWords.get(inputSplit[i]).intValue())-1] =temp + 1; 	
							}
						}
					}
					
				}
			
		}catch(Exception e)
		{
			e.printStackTrace();
		}
		return advectorArray;
	}
	
	public Map<Long,String> getAdjacentWords(Long id, String docName, String query)
	{
		BufferedReader br;
		Document doc;
		String text=null;
		String biword1="";
		String biword2="";
		boolean isPhrase = false;
		Long adInputId=1L;
		Map<Long, String> adjacentWords = new HashMap<Long, String>();
		try{
			
			if (docName.contains("http"))
			{
				doc = Jsoup.connect(docName).get();
				text = doc.body().text();
			}
			if(text!=null || !text.isEmpty())
			{
				text = text.replaceAll("[^\\w\\d\\s+]","");
				String[] tags = StopWordsHelper.removeStopWords(text.split(" "));
				String[] queryArr=null;
				if(query.contains(" ")){
				queryArr= query.split(" ");
				}
				else{
					queryArr= new String[1];
					queryArr[0]=query;
				}
			for(int j=0; j< queryArr.length ; j++ )
			{
				if(queryArr.length >1 && (j+1) < queryArr.length)
				{
					biword1 = queryArr[j];
					biword2 = queryArr[j+1];
					isPhrase = true;
				}
				else if(queryArr.length==1)
				{
					biword1=queryArr[j];
				}
				else
				{
					break;
				}
				for (int i=0; i < tags.length ;i++)
				{
					if(biword1.equalsIgnoreCase(tags[i]))
					{
						int range = 0;
						String docString="";
						if( i > 3){
							range = i -3;
						}
						while(range <= (i+3) && range <tags.length)
						{
							docString = docString +" "+tags[range]; 
							range++;
						}
						adjacentWords.put(adInputId, docString);
						adInputId++;
					}
					
					if(isPhrase)
					{
						if(biword1.equalsIgnoreCase(tags[i]) || biword2.equalsIgnoreCase(tags[i]))
						{
							int range = 0;
							String docString="";
							if( i > 3){
								range = i -3;
							}
							while(range <= (i+3) && range <tags.length)
							{
								docString = docString +" "+tags[range]; 
								range++;
							}
							adjacentWords.put(adInputId, docString);
							adInputId++;
						}
					}
				}
			}
		}
			
		}catch(Exception e){
			e.printStackTrace();
		}
		
		return adjacentWords;
	}
	
	
	public static void main(String[] args)
	{
		//IRServiceHelper.readLinesforAd("G:\\SJSU course\\fall 14\\CS 297\\ads.txt");
	}
}

	